<?xml version="1.0"?>
<queryset>
<rdbms><type>postgresql</type><version>7.1</version></rdbms>

<fullquery name="dtype::form::create.create_form">      
      <querytext>

          select dtype_form__create (
                :layout,
                :widget,
                :custom
          );

      </querytext>
</fullquery>

<fullquery name="dtype::form::delete.delete_form">      
      <querytext>

          select dtype_form__delete (:form_id);

      </querytext>
</fullquery>

<fullquery name="dtype::form::map_type.map_type">      
      <querytext>

          select dtype_form__map_type (:form_id, :form, :object_type);

      </querytext>
</fullquery>

<fullquery name="dtype::element::map_attribute.map_attribute">      
      <querytext>

          select dtype_element__map_attribute (:element_id, :attribute_id);

      </querytext>
</fullquery>

<fullquery name="dtype::layout::create.create_layout">      
      <querytext>

          select dtype_layout__create (
                null,
                :layout,
                :name,
                :description,
                :type,
                :filename,
                :resource_dir
          );

      </querytext>
</fullquery>

<fullquery name="dtype::layout::delete.delete_layout">      
      <querytext>

          select dtype_layout__delete (:layout_id);

      </querytext>
</fullquery>

<fullquery name="dtype::element::add_element.create_element">      
      <querytext>

          select dtype_element__create (
                null,
                :element,
                :parent_id,
                :widget,
                :layout,
                :custom
          );

      </querytext>
</fullquery>

<fullquery name="dtype::element::delete.delete_element">      
      <querytext>

          select dtype_element__delete (:element_id);

      </querytext>
</fullquery>

<fullquery name="dtype::element::add_parameter.add_parameter">      
      <querytext>

          select dtype_proc_param_value__create (
                    null,
                    :element_id,
                    param_id,
                    :source,
                    :value
                 )
            from dtype_proc_params
           where proc = 'template::element::create'
             and name = :param;

      </querytext>
</fullquery>

<fullquery name="dtype::element::delete_parameter.delete_parameter">      
      <querytext>

          select dtype_proc_param_value__delete (pv.call_id, pv.param_id)
            from dtype_proc_param_values pv, dtype_proc_params p
           where p.proc = 'template::element::create'
             and name = :param
             and call_id = :element_id
             and p.param_id = pv.param_id;

      </querytext>
</fullquery>

<fullquery name="dtype::form::delete_attribute_widgets.get_widget_forms">
      <querytext>
          select f.name as dform
            from dtype_form_elements fe,
                 dtype_forms f,
                 acs_attributes a
           where fe.form_id = f.form_id
             and a.attribute_id = fe.attribute_id
             and a.object_type = :object_type
             and a.attribute_name = :attribute_name
      </querytext>
</fullquery>

<fullquery name="dtype::form::create_widget_param.create_widget_param">      
      <querytext>

          select dtype_widget__set_param_value (
                :object_type,
                :dform,
                :attribute_name,
                :param_name,
                :value,
                :type,
                :source
          );

      </querytext>
</fullquery>

<fullquery name="dtype::form::process.create_item">      
      <querytext>
        select content_item__new(varchar :item_name,
                                 :item_parent_id,
                                 :item_item_id,
                                 :item_locale,
                                 now(),
                                 :item_creation_user,
                                 null,
                                 :item_creation_ip,
                                 'content_item',
                                 :item_content_type,
                                 null,
                                 null,
                                 'text/plain',
                                 null,
                                 null,
                                 :cr_storage)
      </querytext>
</fullquery>

<fullquery name="dtype::upload_content.upload_text_revision">      
      <querytext>

        update 
          cr_revisions 
        set 
          content = '[DoubleApos [read [set __f [open $file r]]]][close $__f]',
          content_length = [file size $file]
        where 
          revision_id = :revision_id
      
      </querytext>
</fullquery>


<fullquery name="dtype::upload_content.upload_revision">      
      <querytext>

             update cr_revisions 
             set lob = [set __lob_id [db_string new_lob "select empty_lob()"]],
             content_length = [file size $file]
             where revision_id = :revision_id
      
      </querytext>
</fullquery>


<fullquery name="dtype::upload_content.upload_file_revision">      
      <querytext>

        update cr_revisions 
        set content = '[set file_path [cr_create_content_file $item_id $revision_id $file]]',
        content_length = '[cr_file_size $file_path]'
        where revision_id = :revision_id

      </querytext>
</fullquery>

<partialquery name="dtype::form::process.latest_revision">      
      <querytext>
      content_item__get_latest_revision(:item_id)
      </querytext>
</partialquery>
</queryset>
