ad_page_contract {
    Change attribute sort order
} {
    attribute_id:integer,notnull
    direction:notnull
    {return_url "."}
}

set user_id [auth::require_login]
permission::require_permission -object_id [ad_conn package_id] -privilege admin

db_transaction {
    if {$direction eq "up"} {
        set ltgt "<"
        set order_by desc
    } else {
        set ltgt ">"
        set order_by asc
    }

    db_1row this "select object_type, sort_order as this_order from acs_attributes where attribute_id=:attribute_id"
    
    set other_query "select attribute_id as other_id, sort_order as other_order from acs_attributes where object_type=:object_type and sort_order $ltgt :this_order order by sort_order $order_by limit 1"

    db_1row other "$other_query"

    db_dml update_order "update acs_attributes set sort_order = (case when attribute_id=:attribute_id then :other_order else :this_order end) :: integer where attribute_id in (:attribute_id,:other_id)"

    set function "dtype::form::metadata::\[^ \]*_list -no_cache" 
    util_memoize_flush_regexp "$function -object_type \"$object_type\".*"
}


ad_returnredirect $return_url